<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8" name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Danh sách đơn hàng</title>
    <!-- font -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- DataTable -->
    <link rel="stylesheet" href="//cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
    <script src="//cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>
<body>
    <div class="container">
        <!-- title -->
        <div class="row form-group p-4">
            <div class="col-sm-12 text-center">
                <h2 class="font-weight-bold">DANH SÁCH ĐƠN HÀNG</h2>
            </div>
        </div>
        <!-- table -->
        <table class="table table-striped table-bordered table-hover" id="table-order">
            <thead class="font-weight-bold">
                <tr>
                    <td>OrderCode</td>
                    <td>Kích cở combo</td>
                    <td>Loại Pizza</td>
                    <td>Nước uống</td>
                    <td>Thanh tiền</td>
                    <td>Họ và tên</td>
                    <td>Số điện thoại</td>
                    <td>Trạng thái</td>
                    <td>Action</td>
                </tr>
            </thead>
        </table>
    </div>

    <!-- Modal Order-->
    <div class="modal fade" id="modal-order" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="modal-h5-title">Order Detail</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form action="">
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Order Code</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-orderCode">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Pizza size</label>
                            </div>
                            <div class="col-sm-10">
                                <select name="" id="select-pizza-size" class="form-control">
                                    <option value="0">--chọn--</option>
                                    <option value="S">S</option>
                                    <option value="M">M</option>
                                    <option value="L">L</option>
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Đường kính</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-duong-kinh">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Sườn</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-suon">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Salad</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-salad">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Pizza type</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-pizza-type">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">ID voucher</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-id-voucher">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Thanh tiền</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-thanh-tien">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Giảm giá</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-giam-ga">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Loại đồ uống</label>
                            </div>
                            <div class="col-sm-10">
                                <select name="" id="select-drink" class="form-control">
                                    <option value="0">--chọn--</option>
                                    <option value="PESSI"></option>
                                    <option value="COCA"></option>
                                    <option value="TRATAC"></option>
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Số lượng nước</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-so-luong-nuoc">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Họ và tên</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-ho-ten">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Email</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-email">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">số điện thoại</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-phone">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Địa chỉ</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-dia-chi">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Lời nhắn</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-message">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Ngày order</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-ngay-order">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="">Ngày chỉnh sửa</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" id="inp-ngay-chinh-sua">
                            </div>
                        </div>
                    </form>
                    <div class="row form-group">
                        <div class="col-sm-6">
                            <button class="btn btn-danger form-control" id="modal-btn-confirm">Confirm</button>
                        </div>
                        <div class="col-sm-6">
                            <button class="btn btn-warning form-control" id="modal-btn-cancel">Cancel</button>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    
                </div>
            </div>
        </div>
    </div>

</body>
<script>
    //REGION 1
    const gCOL_ORDERCODE = 0;
    const gCOL_SIZE_COMBO = 1;
    const gCOL_TYPE_PIZZA = 2; 
    const gCOL_DRINK = 3;
    const gCOL_THANH_TIEN = 4;
    const gCOL_HO_TEN = 5;
    const gCOL_PHONE = 6;
    const gCOL_STATUS = 7;
    const gCOL_ACTION = 8;
    const gCOL_NAME = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
    var gTable_Order = $("#table-order").DataTable({
        "columns": [
            {"data": gCOL_NAME[gCOL_ORDERCODE]},
            {"data": gCOL_NAME[gCOL_SIZE_COMBO]},
            {"data": gCOL_NAME[gCOL_TYPE_PIZZA]},
            {"data": gCOL_NAME[gCOL_DRINK]},
            {"data": gCOL_NAME[gCOL_THANH_TIEN]},
            {"data": gCOL_NAME[gCOL_HO_TEN]},
            {"data": gCOL_NAME[gCOL_PHONE]},
            {"data": gCOL_NAME[gCOL_STATUS]},
            {"data": gCOL_NAME[gCOL_ACTION]},
        ],
        "columnDefs": [ //định nghĩa lại cột
            {
                "targets": gCOL_ACTION,
                "defaultContent": '<button class="btn btn-primary btn-detail">Chi tiết</button>'
            }
        ]
    });

    var gOrder_Code = 0;
    var gId = 0;
    //REGION 2
    $(document).ready(function(){
        onPageLoading();
        //gán sự kiện nút detail click
        $("#table-order").on('click', '.btn-detail', function(){
            onBtnDetailClick(this);
        })
        //gán sự kiện nút confirm click trên modal
        $("#modal-btn-confirm").on('click', function(){
            onBtnConfirmClick();
        });
        //gán sự kiện nút cancel click
        $("#modal-btn-cancel").on('click', function(){
            onBtnCancelClick();
        });
    })
    //REGION 3
    function onPageLoading(){
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
            type: "GET",
            success: function(response){
                console.log(response);
                loadDataToTable(response);
            },
            error: function(err){
                console.log(err.status);
            }
        })
    }
    //hàm sử lý sự kiện nút detail click
    function onBtnDetailClick(paramBtn){
        //gán id order vào biến toàn cục
        gOrder_Code = getIdOrder(paramBtn);
        //gọi api để lấy order qua id
        callApiGetOrderByOrderCode(gOrder_Code);
        //hiển thị modal
        $("#modal-order").modal('show');

    }
    //hàm sử lý sự kiện nút confirm được click trên modal
    function onBtnConfirmClick(){
        var vTrangThaiObj = {
            trangThai: "confirmed",
        } 
        $.ajax({
            url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
            type: "PUT",
            data: JSON.stringify(vTrangThaiObj),
            contentType: "application/json;charset=UTF-8",
            dataType: 'json',
            success: function(responseObject){
                headlerOrder();
            },
            error: function(error){
            console.assert(error.responseText);
            }
        });
    }
    //hàn sử lý sự kiện nút cancel được click
    function onBtnCancelClick(){
        var vTrangThaiObj = {
            trangThai: "cancel",
        } 
        $.ajax({
            url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
            type: "PUT",
            data: JSON.stringify(vTrangThaiObj),
            contentType: "application/json;charset=UTF-8",
            dataType: 'json',
            success: function(responseObject){
                headlerOrder();
            },
            error: function(error){
            console.assert(error.responseText);
            }
        });
    }
    //REGION 4
    //hàm laod dữ liệu vào table
    function loadDataToTable(paramRes){
        gTable_Order.clear(); //xóa trăng table
        gTable_Order.rows.add(paramRes); // load data
        gTable_Order.draw() // vẽ lại table
    };
    //hàm lấy order code thông qua btn
    function getIdOrder(paramBtn){
        var vRow = $(paramBtn).parents("tr");
        var vData = gTable_Order.row(vRow).data();
        return vData.orderCode;
    }
    //hàm gọi api để lấy order thông qua id
    function callApiGetOrderByOrderCode(paramOrderCode){
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + paramOrderCode,
            type: "GET",
            success: function(response){
                console.log(response)
                showDataOrderToModal(response);
                gId = response.id;
            },
            error: function(err){
                console.log(err.status);
            }
        })
    }
    //hàm hiển thị thông tin order lên modal
    function showDataOrderToModal(paramRes){
        $("#inp-orderCode").val(paramRes.orderCode);
        $("#select-pizza-size").val(paramRes.kichCo);
        $("#inp-duong-kinh").val(paramRes.duongKinh);
        $("#inp-suon").val(paramRes.suon);
        $("#inp-salad").val(paramRes.salad);
        $("#inp-pizza-type").val(paramRes.loaiPizza);
        $("#inp-id-voucher").val(paramRes.idVourcher);
        $("#inp-thanh-tien").val(paramRes.thanhTien);
        $("#inp-giam-ga").val(paramRes.giamGia);
        $("#select-drink").val(paramRes.idLoaiNuocUong);
        $("#inp-so-luong-nuoc").val(paramRes.soLuongNuoc);
        $("#inp-ho-ten").val(paramRes.hoTen);
        $("#inp-email").val(paramRes.hoTen);
        $("#inp-phone").val(paramRes.soDienThoai);
        $("#inp-dia-chi").val(paramRes.diaChi);
        $("#inp-message").val(paramRes.loiNhan);
        $("#inp-ngay-order").val(paramRes.ngayTao);
        $("#inp-ngay-chinh-sua").val(paramRes.ngayCapNhat);
    }
    //hàm hiển thị khi đã cập nhật trạng thái thành công
    function headlerOrder(){
        alert("cập nhật trạng thái thành công");
        onPageLoading();
        $("#modal-order").modal('hide');
    }
</script>
</html>